//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * ベクトル線形補間ヘッダ
 * @author Junpee
 */

#ifndef VECTOR_LINEAR_INTERPOLATOR_H_
#define VECTOR_LINEAR_INTERPOLATOR_H_

#include <Animation/VectorInterpolator/VectorInterpolator.h>

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * ベクトル線形補間
 */
class VectorLinearInterpolator : public VectorInterpolator{
public:
	//--------------------------------------------------------------------------
	/**
	 * コンストラクタ
	 */
	VectorLinearInterpolator();

	/**
	 * デストラクタ
	 */
	virtual ~VectorLinearInterpolator();

	/**
	 * コピーコンストラクタ
	 * @param copy コピー元
	 */
	explicit VectorLinearInterpolator(const VectorLinearInterpolator& copy);

	/**
	 * 代入演算子
	 * @param copy 代入元
	 */
	virtual VectorLinearInterpolator& operator =(
		const VectorLinearInterpolator& copy);

	//--------------------------------------------------------------------------
	/**
	 * 複製
	 * @return 複製されたベクトル補間。呼び出し元でdeleteする必要がある
	 */
	virtual VectorInterpolator* duplicate() const{
		VectorInterpolator* result = new VectorLinearInterpolator(*this);
		return result;
	}

	//--------------------------------------------------------------------------
	/**
	 * 同じ値かどうか
	 * @param target 比較対象
	 * @return 同じ値ならtrueをかえす
	 */
	virtual bool equals(const VectorInterpolator& target) const{
		VectorLinearInterpolator* interpolator =
			target.castVectorLinearInterpolator();
		if(interpolator == NULL){ return false; }
		if(keyCount_ != interpolator->keyCount_){ return false; }
		for(int i = 0; i < keyCount_; i++){
			const Key& key = keys_[i];
			const Key& targetKey = interpolator->keys_[i];
			if(key.value_ != targetKey.value_){ return false; }
			if(key.time_ != targetKey.time_){ return false; }
		}
		return true;
	}

	//--------------------------------------------------------------------------
	// 長さ
	//--------------------------------------------------------------------------
	/**
	 * 長さの取得
	 * @return 長さ
	 */
	virtual float getLength() const;

	//--------------------------------------------------------------------------
	// バウンディング
	//--------------------------------------------------------------------------
	/**
	 * バウンディングボックスの取得
	 * @return バウンディングボックス
	 */
	virtual AxisAlignedBox getBoundingBox() const;

	//--------------------------------------------------------------------------
	// 補間
	//--------------------------------------------------------------------------
	/**
	 * 補間
	 * @param time 時間
	 * @return 補間されたベクトル
	 */
	virtual Vector3 interpolate(float time);

	//--------------------------------------------------------------------------
	// キー
	//--------------------------------------------------------------------------
	/**
	 * キー数の設定
	 * @param keyCount キー数
	 */
	virtual void setKeyCount(int keyCount);

	/**
	 * キー数の取得
	 * @return キー数
	 */
	virtual int getKeyCount() const{ return keyCount_; }

	//--------------------------------------------------------------------------
	/**
	 * キーの設定
	 * @param index キーインデックス
	 * @param time 時間
	 * @param value 値
	 */
	virtual void setKey(int index, float time, const Vector3& value){
		Assert((index >= 0) && (index < keyCount_) && (keys_ != NULL));
		Key& key = keys_[index];
		key.value_ = value;
		key.time_ = time;
	}

	/**
	 * 値の取得
	 * @param index キーインデックス
	 * @return 値
	 */
	virtual const Vector3& getValue(int index) const{
		Assert((index >= 0) && (index < keyCount_) && (keys_ != NULL));
		return keys_[index].value_;
	}

	/**
	 * 時間の取得
	 * @param index キーインデックス
	 * @return 時間
	 */
	virtual float getTime(int index) const{
		Assert((index >= 0) && (index < keyCount_) && (keys_ != NULL));
		return keys_[index].time_;
	}

	//--------------------------------------------------------------------------
	// RTTI
	//--------------------------------------------------------------------------
	/**
	 * ベクトル線形補間かどうか
	 * @return ベクトル線形補間ならtrue
	 */
	virtual bool isVectorLinearInterpolator() const{ return true; }

	//--------------------------------------------------------------------------
private:
	/// キー
	class Key{
	friend class VectorLinearInterpolator;
	private:
		/// 値
		Vector3 value_;
		/// 時間
		float time_;
	};

	// キー
	Key* keys_;
	// キーの数
	int keyCount_;
	// 最後に使用したキーインデックス
	int lastestUseKeyIndex_;

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of VECTOR_LINEAR_INTERPOLATOR_H_
//------------------------------------------------------------------------------
